%define qtdir /usr/lib/qt-1.44
%define version 1.1.2
%define kderelease 10
%define sourcedir stable/%{version}/distribution/tar/generic/source

%define kdename kdebase
%define pamservice kde
Name: %{kdename}
Icon: kde-icon.xpm
URL: http://www.kde.org
Summary: K Desktop Environment - core files
Version: %{version}
Release: %{kderelease}
Serial: 2
Source: ftp://ftp.kde.org:/pub/kde/{sourcedir}/%{kdename}-%{version}.tar.bz2
Source1: KDE.session.gnome
Patch0: kdebase-1.1.2-redhat.patch
Patch1: kdebase-1.1-waitkdm.patch
Patch2: kdebase-1.1.2-dodesktop.patch
Patch3: kdebase-1.1.2-saveoption.patch
Patch4: kdebase-1.1.2-enablepng.patch
Group: User Interface/Desktops
Copyright: GPL
BuildRoot: /var/tmp/%{kdename}-buildroot
Requires: kdesupport
Prefix: /usr

%description
Core applications for the K Desktop Environment.  Included are: kdm
(replacement for xdm), kwm (window manager), kfm (filemanager, web
browser, ftp client, ...), konsole (xterm replacement), kpanel
(application starter and desktop pager), kaudio (audio server),
kdehelp (viewer for kde help files, info and man pages), kthememgr
(system for managing alternate theme packages) plus other KDE
components (kcheckpass, kikbd, kvt, kscreensaver, kcontrol, kfind,
kfontmanager, kmenuedit, kappfinder).

%package lowcolor-icons
Summary: Low color (8 bit display friendly) icons for KDE
Group: User Interface/Desktops
Requires: kdebase

%description lowcolor-icons
The default icons in KDE 1.1.2 are color intensive, and can quickly
use up all available colors on an 8 bit (256 color) display.  Please
install this package if you have such a display adapter to achieve
more efficient allocation of colors when KDE displays icons.


%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n kdebase-%{version}
%patch0 -p1 -b .redhat
%patch1 -p1 -b .waitkdm
%patch2 -p1 -b .dodesktop
%patch3 -p1 -b .saveoption
%patch4 -p1 -b .enablepng

%build
export KDEDIR=/usr QTDIR=%{qtdir}
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS -DNO_DEBUG -DNDEBUG" \
	./configure  \
	--prefix=/usr \
	--with-pam=kde \
	--with-install-root=$RPM_BUILD_ROOT  \
	--without-gl

make

# set up locolor icons
cd pics
tar xzf locolor-icons.tar.gz

%install
make RUN_KAPPFINDER=no install-strip

# install lowcolor icons
mkdir -p $RPM_BUILD_ROOT/usr/share/icons/locolor
cp pics/share/icons/* $RPM_BUILD_ROOT/usr/share/icons/locolor

# do NOT make kvt suid root
chmod 0755 $RPM_BUILD_ROOT/usr/bin/kvt

# make kcheckpass suid root
chmod 1755 $RPM_BUILD_ROOT/usr/bin/kcheckpass

# remove SUID bit from konsole_grantpty
chmod 0755 $RPM_BUILD_ROOT/usr/bin/konsole_grantpty

#install pam configuration file
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -m 0644 $RPM_BUILD_DIR/kdebase-%{version}/kde.pamd \
	$RPM_BUILD_ROOT/etc/pam.d/%{pamservice}

# fix kappfinder script for relocatability
{
	pushd $RPM_BUILD_ROOT/usr/bin
	cp kappfinder kappfinder.temp
	sed -e 's.\$(prefix).\$KDEDIR.g' kappfinder.temp > kappfinder
	rm -f kappfinder.temp
	popd
}

# make symlink for our applnk directory and GNOME directory
{
	pushd $RPM_BUILD_ROOT/usr/share/applnk
	mkdir -p $RPM_BUILD_ROOT/etc/X11/applnk
	cat > $RPM_BUILD_ROOT/etc/X11/applnk/.directory << EOF
# KDE Config File
[KDE Desktop Entry]
Icon=/usr/share/pixmaps/redhat/shadowman-round-32.xpm
MiniIcon=/usr/share/pixmaps/redhat/shadowman-round-mini.xpm
Name=Red Hat
EOF

	ln -sf ../../../etc/X11/applnk redhat

	mkdir -p $RPM_BUILD_ROOT/usr/share/gnome/apps
	cat > $RPM_BUILD_ROOT/usr/share/gnome/apps/.directory << EOF
# KDE Config File
[KDE Desktop Entry]
Icon=/usr/share/pixmaps/gnome-logo-icon-transparent.png
Name=GNOME
EOF
	
	ln -sf ../gnome/apps gnome

	popd
}

# menu layout changes
{
	pushd $RPM_BUILD_ROOT/usr/share/applnk
	mv Krefresh.kdelnk Kfind.kdelnk Trash.kdelnk Utilities/
	popd
}

# fix konsole /opt/kde hardcode
{
	pushd konsole/other
	perl -pi -e "s|/opt/kde|/usr|g" *
	popd
}


# remove some icons that conflict with fvwm2-icons
rm $RPM_BUILD_ROOT/usr/share/icons/bell.xpm
rm $RPM_BUILD_ROOT/usr/share/icons/mini/mini.*

{
	pushd $RPM_BUILD_ROOT
	find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
		$RPM_BUILD_DIR/file.list.%{kdename}

	find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
		-e '/\/config\//s|^|%config|' >> \
		$RPM_BUILD_DIR/file.list.%{kdename}

	find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
		$RPM_BUILD_DIR/file.list.%{kdename}

	grep -v lowcolor $RPM_BUILD_DIR/file.list.%{kdename} > \
		$RPM_BUILD_DIR/file.list.%{kdename}.temp
	mv $RPM_BUILD_DIR/file.list.%{kdename}.temp \
		$RPM_BUILD_DIR/file.list.%{kdename}
        
	echo "%docdir /usr/doc/kde" >> \
		$RPM_BUILD_DIR/file.list.%{kdename}

	popd
}

# install gdm session support
mkdir -p $RPM_BUILD_ROOT/etc/X11/gdm/Sessions
install -m 755 $RPM_SOURCE_DIR/KDE.session.gnome \
	$RPM_BUILD_ROOT/etc/X11/gdm/Sessions/KDE

# install the linux console fonts
install -d -m 755 $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc
install -m 644 konsole/other/*.pcf.gz \
	$RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/files.list.%{kdename}

%post
cd /usr/X11R6/lib/X11/fonts/misc && mkfontdir

%postun
if [ "$1" = "0" ]; then
  cd /usr/X11R6/lib/X11/fonts/misc && mkfontdir
fi

%files -f ../file.list.%{kdename} 
%attr(-,root,root) /etc/X11/gdm/Sessions/KDE
%attr(-,root,root) /usr/X11R6/lib/X11/fonts/misc/*

%files lowcolor-icons
/usr/share/icons/locolor

%changelog
* Thu Sep 23 1999 Preston Brown <pbrown@redhat.com>
- clean up files in /tmp from startkde
- mark doc files as such

* Tue Sep 21 1999 Preston Brown <pbrown@redhat.com>
- start autorun if present in startkde
- check for configured soundcard before running sound services

* Mon Sep 20 1999 Preston Brown <pbrown@redhat.com>
- made kdelnks display Name property if they are of type Link

* Thu Sep 16 1999 Preston Brown <pbrown@redhat.com>
- moved png handling here (from kdelibs)
- changed low color icon directory name to locolor

* Tue Sep 14 1999 Preston Brown <pbrown@redhat.com>
- added optional session management to logout dialog
- include GNOME menus

* Mon Sep 13 1999 Preston Brown <pbrown@redhat.com>
- added link to /etc/X11/applnk, .directory file
- included lowcolor icon sub-package
- enable .desktop file access

* Fri Sep 10 1999 Preston Brown <pbrown@redhat.com>
- customized startkde script to set up user environment if not present.
- mention kthememgr in description.

* Wed Sep 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 1.1.2 release
- kvt is back
- kde icon included
- linux console fonts included

* Thu Jul 15 1999 Preston Brown <pbrown@redhat.com>
- PAM console logout problem solved.

* Mon Jul 12 1999 Preston Brown <pbrown@redhat.com>
- now includes screensaver password security fix

* Fri Jun 11 1999 Preston Brown <pbrown@redhat.com>
- snapshot, includes kde 1.1.1 + fixes
- kvt removed for security reasons.  It is a steaming pile of...

* Mon Apr 19 1999 Preston Brown <pbrown@redhat.com> 
- last snapshot before release

* Fri Apr 16 1999 Preston Brown <pbrown@redhat.com>
- today's snapshot makes kfm a bit nicer and some other fixes
- moved default rc files to kdesupport

* Thu Apr 15 1999 Preston Brown <pbrown@redhat.com>
- SUID bit removed from konsole_grantpty -- not needed w/glibc 2.1

* Wed Apr 14 1999 Preston Brown <pbrown@redhat.com>
- built with today's snapshot -- had to rebuild to fix pam problems.

* Tue Apr 13 1999 Preston Brown <pbrown@redhat.com>
- new snapshot fixes mimetype video/x-flic problem

* Mon Apr 12 1999 Preston Brown <pbrown@redhat.com>
- latest stable snapshot

* Fri Apr 09 1999 Preston Brown <pbrown@redhat.com>
- removed bell.xpm (used to be in fvwm2-icons, don't want installer to see
- this previous connection and autoselect kdebase for upgrade).

* Tue Mar 23 1999 Preston Brown <pbrown@redhat.com>
- moved gdm patch

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- added gdm session control file

* Fri Mar 19 1999 Preston Brown <pbrown@redhat.com>
- added pam-console stuff to kde pam file

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Mon Feb 07 1999 Preston Brown <pbrown@redhat.com>
- upgraded to KDE 1.1 final.

* Tue Jan 19 1999 Preston Brown <pbrown@redhat.com>
- updated macros for RPM 3.0, removed red hat logo.

* Tue Jan 05 1999 Preston Brown <pbrown@redhat.com>
- re-merged from Duncan Haldane's stuff
